Merge branch 'en/rebase-merge-on-sequencer'
[git] / t / test-lib-functions.sh
1 # Library of functions shared by all tests scripts, included by
2 # test-lib.sh.
3 #
4 # Copyright (c) 2005 Junio C Hamano
5 #
6 # This program is free software: you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation, either version 2 of the License, or
9 # (at your option) any later version.
10 #
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
14 # GNU General Public License for more details.
15 #
16 # You should have received a copy of the GNU General Public License
17 # along with this program.  If not, see http://www.gnu.org/licenses/ .
18
19 # The semantics of the editor variables are that of invoking
20 # sh -c "$EDITOR \"$@\"" files ...
21 #
22 # If our trash directory contains shell metacharacters, they will be
23 # interpreted if we just set $EDITOR directly, so do a little dance with
24 # environment variables to work around this.
25 #
26 # In particular, quoting isn't enough, as the path may contain the same quote
27 # that we're using.
28 test_set_editor () {
29         FAKE_EDITOR="$1"
30         export FAKE_EDITOR
31         EDITOR='"$FAKE_EDITOR"'
32         export EDITOR
33 }
34
35 test_set_index_version () {
36     GIT_INDEX_VERSION="$1"
37     export GIT_INDEX_VERSION
38 }
39
40 test_decode_color () {
41         awk '
42                 function name(n) {
43                         if (n == 0) return "RESET";
44                         if (n == 1) return "BOLD";
45                         if (n == 2) return "FAINT";
46                         if (n == 3) return "ITALIC";
47                         if (n == 7) return "REVERSE";
48                         if (n == 30) return "BLACK";
49                         if (n == 31) return "RED";
50                         if (n == 32) return "GREEN";
51                         if (n == 33) return "YELLOW";
52                         if (n == 34) return "BLUE";
53                         if (n == 35) return "MAGENTA";
54                         if (n == 36) return "CYAN";
55                         if (n == 37) return "WHITE";
56                         if (n == 40) return "BLACK";
57                         if (n == 41) return "BRED";
58                         if (n == 42) return "BGREEN";
59                         if (n == 43) return "BYELLOW";
60                         if (n == 44) return "BBLUE";
61                         if (n == 45) return "BMAGENTA";
62                         if (n == 46) return "BCYAN";
63                         if (n == 47) return "BWHITE";
64                 }
65                 {
66                         while (match($0, /\033\[[0-9;]*m/) != 0) {
67                                 printf "%s<", substr($0, 1, RSTART-1);
68                                 codes = substr($0, RSTART+2, RLENGTH-3);
69                                 if (length(codes) == 0)
70                                         printf "%s", name(0)
71                                 else {
72                                         n = split(codes, ary, ";");
73                                         sep = "";
74                                         for (i = 1; i <= n; i++) {
75                                                 printf "%s%s", sep, name(ary[i]);
76                                                 sep = ";"
77                                         }
78                                 }
79                                 printf ">";
80                                 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
81                         }
82                         print
83                 }
84         '
85 }
86
87 lf_to_nul () {
88         perl -pe 'y/\012/\000/'
89 }
90
91 nul_to_q () {
92         perl -pe 'y/\000/Q/'
93 }
94
95 q_to_nul () {
96         perl -pe 'y/Q/\000/'
97 }
98
99 q_to_cr () {
100         tr Q '\015'
101 }
102
103 q_to_tab () {
104         tr Q '\011'
105 }
106
107 qz_to_tab_space () {
108         tr QZ '\011\040'
109 }
110
111 append_cr () {
112         sed -e 's/$/Q/' | tr Q '\015'
113 }
114
115 remove_cr () {
116         tr '\015' Q | sed -e 's/Q$//'
117 }
118
119 # Generate an output of $1 bytes of all zeroes (NULs, not ASCII zeroes).
120 # If $1 is 'infinity', output forever or until the receiving pipe stops reading,
121 # whichever comes first.
122 generate_zero_bytes () {
123         perl -e 'if ($ARGV[0] == "infinity") {
124                 while (-1) {
125                         print "\0"
126                 }
127         } else {
128                 print "\0" x $ARGV[0]
129         }' "$@"
130 }
131
132 # In some bourne shell implementations, the "unset" builtin returns
133 # nonzero status when a variable to be unset was not set in the first
134 # place.
135 #
136 # Use sane_unset when that should not be considered an error.
137
138 sane_unset () {
139         unset "$@"
140         return 0
141 }
142
143 test_tick () {
144         if test -z "${test_tick+set}"
145         then
146                 test_tick=1112911993
147         else
148                 test_tick=$(($test_tick + 60))
149         fi
150         GIT_COMMITTER_DATE="$test_tick -0700"
151         GIT_AUTHOR_DATE="$test_tick -0700"
152         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
153 }
154
155 # Stop execution and start a shell. This is useful for debugging tests.
156 #
157 # Be sure to remove all invocations of this command before submitting.
158
159 test_pause () {
160         "$SHELL_PATH" <&6 >&5 2>&7
161 }
162
163 # Wrap git with a debugger. Adding this to a command can make it easier
164 # to understand what is going on in a failing test.
165 #
166 # Examples:
167 #     debug git checkout master
168 #     debug --debugger=nemiver git $ARGS
169 #     debug -d "valgrind --tool=memcheck --track-origins=yes" git $ARGS
170 debug () {
171         case "$1" in
172         -d)
173                 GIT_DEBUGGER="$2" &&
174                 shift 2
175                 ;;
176         --debugger=*)
177                 GIT_DEBUGGER="${1#*=}" &&
178                 shift 1
179                 ;;
180         *)
181                 GIT_DEBUGGER=1
182                 ;;
183         esac &&
184         GIT_DEBUGGER="${GIT_DEBUGGER}" "$@" <&6 >&5 2>&7
185 }
186
187 # Call test_commit with the arguments
188 # [-C <directory>] <message> [<file> [<contents> [<tag>]]]"
189 #
190 # This will commit a file with the given contents and the given commit
191 # message, and tag the resulting commit with the given tag name.
192 #
193 # <file>, <contents>, and <tag> all default to <message>.
194 #
195 # If the first argument is "-C", the second argument is used as a path for
196 # the git invocations.
197
198 test_commit () {
199         notick= &&
200         signoff= &&
201         indir= &&
202         while test $# != 0
203         do
204                 case "$1" in
205                 --notick)
206                         notick=yes
207                         ;;
208                 --signoff)
209                         signoff="$1"
210                         ;;
211                 -C)
212                         indir="$2"
213                         shift
214                         ;;
215                 *)
216                         break
217                         ;;
218                 esac
219                 shift
220         done &&
221         indir=${indir:+"$indir"/} &&
222         file=${2:-"$1.t"} &&
223         echo "${3-$1}" > "$indir$file" &&
224         git ${indir:+ -C "$indir"} add "$file" &&
225         if test -z "$notick"
226         then
227                 test_tick
228         fi &&
229         git ${indir:+ -C "$indir"} commit $signoff -m "$1" &&
230         git ${indir:+ -C "$indir"} tag "${4:-$1}"
231 }
232
233 # Call test_merge with the arguments "<message> <commit>", where <commit>
234 # can be a tag pointing to the commit-to-merge.
235
236 test_merge () {
237         test_tick &&
238         git merge -m "$1" "$2" &&
239         git tag "$1"
240 }
241
242 # This function helps systems where core.filemode=false is set.
243 # Use it instead of plain 'chmod +x' to set or unset the executable bit
244 # of a file in the working directory and add it to the index.
245
246 test_chmod () {
247         chmod "$@" &&
248         git update-index --add "--chmod=$@"
249 }
250
251 # Get the modebits from a file.
252 test_modebits () {
253         ls -l "$1" | sed -e 's|^\(..........\).*|\1|'
254 }
255
256 # Unset a configuration variable, but don't fail if it doesn't exist.
257 test_unconfig () {
258         config_dir=
259         if test "$1" = -C
260         then
261                 shift
262                 config_dir=$1
263                 shift
264         fi
265         git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
266         config_status=$?
267         case "$config_status" in
268         5) # ok, nothing to unset
269                 config_status=0
270                 ;;
271         esac
272         return $config_status
273 }
274
275 # Set git config, automatically unsetting it after the test is over.
276 test_config () {
277         config_dir=
278         if test "$1" = -C
279         then
280                 shift
281                 config_dir=$1
282                 shift
283         fi
284         test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
285         git ${config_dir:+-C "$config_dir"} config "$@"
286 }
287
288 test_config_global () {
289         test_when_finished "test_unconfig --global '$1'" &&
290         git config --global "$@"
291 }
292
293 write_script () {
294         {
295                 echo "#!${2-"$SHELL_PATH"}" &&
296                 cat
297         } >"$1" &&
298         chmod +x "$1"
299 }
300
301 # Use test_set_prereq to tell that a particular prerequisite is available.
302 # The prerequisite can later be checked for in two ways:
303 #
304 # - Explicitly using test_have_prereq.
305 #
306 # - Implicitly by specifying the prerequisite tag in the calls to
307 #   test_expect_{success,failure,code}.
308 #
309 # The single parameter is the prerequisite tag (a simple word, in all
310 # capital letters by convention).
311
312 test_unset_prereq () {
313         ! test_have_prereq "$1" ||
314         satisfied_prereq="${satisfied_prereq% $1 *} ${satisfied_prereq#* $1 }"
315 }
316
317 test_set_prereq () {
318         case "$1" in
319         !*)
320                 test_unset_prereq "${1#!}"
321                 ;;
322         *)
323                 satisfied_prereq="$satisfied_prereq$1 "
324                 ;;
325         esac
326 }
327 satisfied_prereq=" "
328 lazily_testable_prereq= lazily_tested_prereq=
329
330 # Usage: test_lazy_prereq PREREQ 'script'
331 test_lazy_prereq () {
332         lazily_testable_prereq="$lazily_testable_prereq$1 "
333         eval test_prereq_lazily_$1=\$2
334 }
335
336 test_run_lazy_prereq_ () {
337         script='
338 mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
339 (
340         cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
341 )'
342         say >&3 "checking prerequisite: $1"
343         say >&3 "$script"
344         test_eval_ "$script"
345         eval_ret=$?
346         rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
347         if test "$eval_ret" = 0; then
348                 say >&3 "prerequisite $1 ok"
349         else
350                 say >&3 "prerequisite $1 not satisfied"
351         fi
352         return $eval_ret
353 }
354
355 test_have_prereq () {
356         # prerequisites can be concatenated with ','
357         save_IFS=$IFS
358         IFS=,
359         set -- $*
360         IFS=$save_IFS
361
362         total_prereq=0
363         ok_prereq=0
364         missing_prereq=
365
366         for prerequisite
367         do
368                 case "$prerequisite" in
369                 !*)
370                         negative_prereq=t
371                         prerequisite=${prerequisite#!}
372                         ;;
373                 *)
374                         negative_prereq=
375                 esac
376
377                 case " $lazily_tested_prereq " in
378                 *" $prerequisite "*)
379                         ;;
380                 *)
381                         case " $lazily_testable_prereq " in
382                         *" $prerequisite "*)
383                                 eval "script=\$test_prereq_lazily_$prerequisite" &&
384                                 if test_run_lazy_prereq_ "$prerequisite" "$script"
385                                 then
386                                         test_set_prereq $prerequisite
387                                 fi
388                                 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
389                         esac
390                         ;;
391                 esac
392
393                 total_prereq=$(($total_prereq + 1))
394                 case "$satisfied_prereq" in
395                 *" $prerequisite "*)
396                         satisfied_this_prereq=t
397                         ;;
398                 *)
399                         satisfied_this_prereq=
400                 esac
401
402                 case "$satisfied_this_prereq,$negative_prereq" in
403                 t,|,t)
404                         ok_prereq=$(($ok_prereq + 1))
405                         ;;
406                 *)
407                         # Keep a list of missing prerequisites; restore
408                         # the negative marker if necessary.
409                         prerequisite=${negative_prereq:+!}$prerequisite
410                         if test -z "$missing_prereq"
411                         then
412                                 missing_prereq=$prerequisite
413                         else
414                                 missing_prereq="$prerequisite,$missing_prereq"
415                         fi
416                 esac
417         done
418
419         test $total_prereq = $ok_prereq
420 }
421
422 test_declared_prereq () {
423         case ",$test_prereq," in
424         *,$1,*)
425                 return 0
426                 ;;
427         esac
428         return 1
429 }
430
431 test_verify_prereq () {
432         test -z "$test_prereq" ||
433         expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
434         BUG "'$test_prereq' does not look like a prereq"
435 }
436
437 test_expect_failure () {
438         test_start_
439         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
440         test "$#" = 2 ||
441         BUG "not 2 or 3 parameters to test-expect-failure"
442         test_verify_prereq
443         export test_prereq
444         if ! test_skip "$@"
445         then
446                 say >&3 "checking known breakage: $2"
447                 if test_run_ "$2" expecting_failure
448                 then
449                         test_known_broken_ok_ "$1"
450                 else
451                         test_known_broken_failure_ "$1"
452                 fi
453         fi
454         test_finish_
455 }
456
457 test_expect_success () {
458         test_start_
459         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
460         test "$#" = 2 ||
461         BUG "not 2 or 3 parameters to test-expect-success"
462         test_verify_prereq
463         export test_prereq
464         if ! test_skip "$@"
465         then
466                 say >&3 "expecting success: $2"
467                 if test_run_ "$2"
468                 then
469                         test_ok_ "$1"
470                 else
471                         test_failure_ "$@"
472                 fi
473         fi
474         test_finish_
475 }
476
477 # test_external runs external test scripts that provide continuous
478 # test output about their progress, and succeeds/fails on
479 # zero/non-zero exit code.  It outputs the test output on stdout even
480 # in non-verbose mode, and announces the external script with "# run
481 # <n>: ..." before running it.  When providing relative paths, keep in
482 # mind that all scripts run in "trash directory".
483 # Usage: test_external description command arguments...
484 # Example: test_external 'Perl API' perl ../path/to/test.pl
485 test_external () {
486         test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
487         test "$#" = 3 ||
488         BUG "not 3 or 4 parameters to test_external"
489         descr="$1"
490         shift
491         test_verify_prereq
492         export test_prereq
493         if ! test_skip "$descr" "$@"
494         then
495                 # Announce the script to reduce confusion about the
496                 # test output that follows.
497                 say_color "" "# run $test_count: $descr ($*)"
498                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
499                 # to be able to use them in script
500                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
501                 # Run command; redirect its stderr to &4 as in
502                 # test_run_, but keep its stdout on our stdout even in
503                 # non-verbose mode.
504                 "$@" 2>&4
505                 if test "$?" = 0
506                 then
507                         if test $test_external_has_tap -eq 0; then
508                                 test_ok_ "$descr"
509                         else
510                                 say_color "" "# test_external test $descr was ok"
511                                 test_success=$(($test_success + 1))
512                         fi
513                 else
514                         if test $test_external_has_tap -eq 0; then
515                                 test_failure_ "$descr" "$@"
516                         else
517                                 say_color error "# test_external test $descr failed: $@"
518                                 test_failure=$(($test_failure + 1))
519                         fi
520                 fi
521         fi
522 }
523
524 # Like test_external, but in addition tests that the command generated
525 # no output on stderr.
526 test_external_without_stderr () {
527         # The temporary file has no (and must have no) security
528         # implications.
529         tmp=${TMPDIR:-/tmp}
530         stderr="$tmp/git-external-stderr.$$.tmp"
531         test_external "$@" 4> "$stderr"
532         test -f "$stderr" || error "Internal error: $stderr disappeared."
533         descr="no stderr: $1"
534         shift
535         say >&3 "# expecting no stderr from previous command"
536         if test ! -s "$stderr"
537         then
538                 rm "$stderr"
539
540                 if test $test_external_has_tap -eq 0; then
541                         test_ok_ "$descr"
542                 else
543                         say_color "" "# test_external_without_stderr test $descr was ok"
544                         test_success=$(($test_success + 1))
545                 fi
546         else
547                 if test "$verbose" = t
548                 then
549                         output=$(echo; echo "# Stderr is:"; cat "$stderr")
550                 else
551                         output=
552                 fi
553                 # rm first in case test_failure exits.
554                 rm "$stderr"
555                 if test $test_external_has_tap -eq 0; then
556                         test_failure_ "$descr" "$@" "$output"
557                 else
558                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
559                         test_failure=$(($test_failure + 1))
560                 fi
561         fi
562 }
563
564 # debugging-friendly alternatives to "test [-f|-d|-e]"
565 # The commands test the existence or non-existence of $1. $2 can be
566 # given to provide a more precise diagnosis.
567 test_path_is_file () {
568         if ! test -f "$1"
569         then
570                 echo "File $1 doesn't exist. $2"
571                 false
572         fi
573 }
574
575 test_path_is_dir () {
576         if ! test -d "$1"
577         then
578                 echo "Directory $1 doesn't exist. $2"
579                 false
580         fi
581 }
582
583 test_path_exists () {
584         if ! test -e "$1"
585         then
586                 echo "Path $1 doesn't exist. $2"
587                 false
588         fi
589 }
590
591 # Check if the directory exists and is empty as expected, barf otherwise.
592 test_dir_is_empty () {
593         test_path_is_dir "$1" &&
594         if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
595         then
596                 echo "Directory '$1' is not empty, it contains:"
597                 ls -la "$1"
598                 return 1
599         fi
600 }
601
602 test_path_is_missing () {
603         if test -e "$1"
604         then
605                 echo "Path exists:"
606                 ls -ld "$1"
607                 if test $# -ge 1
608                 then
609                         echo "$*"
610                 fi
611                 false
612         fi
613 }
614
615 # test_line_count checks that a file has the number of lines it
616 # ought to. For example:
617 #
618 #       test_expect_success 'produce exactly one line of output' '
619 #               do something >output &&
620 #               test_line_count = 1 output
621 #       '
622 #
623 # is like "test $(wc -l <output) = 1" except that it passes the
624 # output through when the number of lines is wrong.
625
626 test_line_count () {
627         if test $# != 3
628         then
629                 BUG "not 3 parameters to test_line_count"
630         elif ! test $(wc -l <"$3") "$1" "$2"
631         then
632                 echo "test_line_count: line count for $3 !$1 $2"
633                 cat "$3"
634                 return 1
635         fi
636 }
637
638 # Returns success if a comma separated string of keywords ($1) contains a
639 # given keyword ($2).
640 # Examples:
641 # `list_contains "foo,bar" bar` returns 0
642 # `list_contains "foo" bar` returns 1
643
644 list_contains () {
645         case ",$1," in
646         *,$2,*)
647                 return 0
648                 ;;
649         esac
650         return 1
651 }
652
653 # This is not among top-level (test_expect_success | test_expect_failure)
654 # but is a prefix that can be used in the test script, like:
655 #
656 #       test_expect_success 'complain and die' '
657 #           do something &&
658 #           do something else &&
659 #           test_must_fail git checkout ../outerspace
660 #       '
661 #
662 # Writing this as "! git checkout ../outerspace" is wrong, because
663 # the failure could be due to a segv.  We want a controlled failure.
664 #
665 # Accepts the following options:
666 #
667 #   ok=<signal-name>[,<...>]:
668 #     Don't treat an exit caused by the given signal as error.
669 #     Multiple signals can be specified as a comma separated list.
670 #     Currently recognized signal names are: sigpipe, success.
671 #     (Don't use 'success', use 'test_might_fail' instead.)
672
673 test_must_fail () {
674         case "$1" in
675         ok=*)
676                 _test_ok=${1#ok=}
677                 shift
678                 ;;
679         *)
680                 _test_ok=
681                 ;;
682         esac
683         "$@" 2>&7
684         exit_code=$?
685         if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
686         then
687                 echo >&4 "test_must_fail: command succeeded: $*"
688                 return 1
689         elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
690         then
691                 return 0
692         elif test $exit_code -gt 129 && test $exit_code -le 192
693         then
694                 echo >&4 "test_must_fail: died by signal $(($exit_code - 128)): $*"
695                 return 1
696         elif test $exit_code -eq 127
697         then
698                 echo >&4 "test_must_fail: command not found: $*"
699                 return 1
700         elif test $exit_code -eq 126
701         then
702                 echo >&4 "test_must_fail: valgrind error: $*"
703                 return 1
704         fi
705         return 0
706 } 7>&2 2>&4
707
708 # Similar to test_must_fail, but tolerates success, too.  This is
709 # meant to be used in contexts like:
710 #
711 #       test_expect_success 'some command works without configuration' '
712 #               test_might_fail git config --unset all.configuration &&
713 #               do something
714 #       '
715 #
716 # Writing "git config --unset all.configuration || :" would be wrong,
717 # because we want to notice if it fails due to segv.
718 #
719 # Accepts the same options as test_must_fail.
720
721 test_might_fail () {
722         test_must_fail ok=success "$@" 2>&7
723 } 7>&2 2>&4
724
725 # Similar to test_must_fail and test_might_fail, but check that a
726 # given command exited with a given exit code. Meant to be used as:
727 #
728 #       test_expect_success 'Merge with d/f conflicts' '
729 #               test_expect_code 1 git merge "merge msg" B master
730 #       '
731
732 test_expect_code () {
733         want_code=$1
734         shift
735         "$@" 2>&7
736         exit_code=$?
737         if test $exit_code = $want_code
738         then
739                 return 0
740         fi
741
742         echo >&4 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
743         return 1
744 } 7>&2 2>&4
745
746 # test_cmp is a helper function to compare actual and expected output.
747 # You can use it like:
748 #
749 #       test_expect_success 'foo works' '
750 #               echo expected >expected &&
751 #               foo >actual &&
752 #               test_cmp expected actual
753 #       '
754 #
755 # This could be written as either "cmp" or "diff -u", but:
756 # - cmp's output is not nearly as easy to read as diff -u
757 # - not all diff versions understand "-u"
758
759 test_cmp() {
760         $GIT_TEST_CMP "$@"
761 }
762
763 # Check that the given config key has the expected value.
764 #
765 #    test_cmp_config [-C <dir>] <expected-value>
766 #                    [<git-config-options>...] <config-key>
767 #
768 # for example to check that the value of core.bar is foo
769 #
770 #    test_cmp_config foo core.bar
771 #
772 test_cmp_config() {
773         local GD &&
774         if test "$1" = "-C"
775         then
776                 shift &&
777                 GD="-C $1" &&
778                 shift
779         fi &&
780         printf "%s\n" "$1" >expect.config &&
781         shift &&
782         git $GD config "$@" >actual.config &&
783         test_cmp expect.config actual.config
784 }
785
786 # test_cmp_bin - helper to compare binary files
787
788 test_cmp_bin() {
789         cmp "$@"
790 }
791
792 # Use this instead of test_cmp to compare files that contain expected and
793 # actual output from git commands that can be translated.  When running
794 # under GIT_TEST_GETTEXT_POISON this pretends that the command produced expected
795 # results.
796 test_i18ncmp () {
797         ! test_have_prereq C_LOCALE_OUTPUT || test_cmp "$@"
798 }
799
800 # Use this instead of "grep expected-string actual" to see if the
801 # output from a git command that can be translated either contains an
802 # expected string, or does not contain an unwanted one.  When running
803 # under GIT_TEST_GETTEXT_POISON this pretends that the command produced expected
804 # results.
805 test_i18ngrep () {
806         eval "last_arg=\${$#}"
807
808         test -f "$last_arg" ||
809         BUG "test_i18ngrep requires a file to read as the last parameter"
810
811         if test $# -lt 2 ||
812            { test "x!" = "x$1" && test $# -lt 3 ; }
813         then
814                 BUG "too few parameters to test_i18ngrep"
815         fi
816
817         if test_have_prereq !C_LOCALE_OUTPUT
818         then
819                 # pretend success
820                 return 0
821         fi
822
823         if test "x!" = "x$1"
824         then
825                 shift
826                 ! grep "$@" && return 0
827
828                 echo >&4 "error: '! grep $@' did find a match in:"
829         else
830                 grep "$@" && return 0
831
832                 echo >&4 "error: 'grep $@' didn't find a match in:"
833         fi
834
835         if test -s "$last_arg"
836         then
837                 cat >&4 "$last_arg"
838         else
839                 echo >&4 "<File '$last_arg' is empty>"
840         fi
841
842         return 1
843 }
844
845 # Call any command "$@" but be more verbose about its
846 # failure. This is handy for commands like "test" which do
847 # not output anything when they fail.
848 verbose () {
849         "$@" && return 0
850         echo >&4 "command failed: $(git rev-parse --sq-quote "$@")"
851         return 1
852 }
853
854 # Check if the file expected to be empty is indeed empty, and barfs
855 # otherwise.
856
857 test_must_be_empty () {
858         test_path_is_file "$1" &&
859         if test -s "$1"
860         then
861                 echo "'$1' is not empty, it contains:"
862                 cat "$1"
863                 return 1
864         fi
865 }
866
867 # Tests that its two parameters refer to the same revision
868 test_cmp_rev () {
869         if test $# != 2
870         then
871                 error "bug in the test script: test_cmp_rev requires two revisions, but got $#"
872         else
873                 local r1 r2
874                 r1=$(git rev-parse --verify "$1") &&
875                 r2=$(git rev-parse --verify "$2") &&
876                 if test "$r1" != "$r2"
877                 then
878                         cat >&4 <<-EOF
879                         error: two revisions point to different objects:
880                           '$1': $r1
881                           '$2': $r2
882                         EOF
883                         return 1
884                 fi
885         fi
886 }
887
888 # Print a sequence of integers in increasing order, either with
889 # two arguments (start and end):
890 #
891 #     test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
892 #
893 # or with one argument (end), in which case it starts counting
894 # from 1.
895
896 test_seq () {
897         case $# in
898         1)      set 1 "$@" ;;
899         2)      ;;
900         *)      BUG "not 1 or 2 parameters to test_seq" ;;
901         esac
902         test_seq_counter__=$1
903         while test "$test_seq_counter__" -le "$2"
904         do
905                 echo "$test_seq_counter__"
906                 test_seq_counter__=$(( $test_seq_counter__ + 1 ))
907         done
908 }
909
910 # This function can be used to schedule some commands to be run
911 # unconditionally at the end of the test to restore sanity:
912 #
913 #       test_expect_success 'test core.capslock' '
914 #               git config core.capslock true &&
915 #               test_when_finished "git config --unset core.capslock" &&
916 #               hello world
917 #       '
918 #
919 # That would be roughly equivalent to
920 #
921 #       test_expect_success 'test core.capslock' '
922 #               git config core.capslock true &&
923 #               hello world
924 #               git config --unset core.capslock
925 #       '
926 #
927 # except that the greeting and config --unset must both succeed for
928 # the test to pass.
929 #
930 # Note that under --immediate mode, no clean-up is done to help diagnose
931 # what went wrong.
932
933 test_when_finished () {
934         # We cannot detect when we are in a subshell in general, but by
935         # doing so on Bash is better than nothing (the test will
936         # silently pass on other shells).
937         test "${BASH_SUBSHELL-0}" = 0 ||
938         BUG "test_when_finished does nothing in a subshell"
939         test_cleanup="{ $*
940                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
941 }
942
943 # Most tests can use the created repository, but some may need to create more.
944 # Usage: test_create_repo <directory>
945 test_create_repo () {
946         test "$#" = 1 ||
947         BUG "not 1 parameter to test-create-repo"
948         repo="$1"
949         mkdir -p "$repo"
950         (
951                 cd "$repo" || error "Cannot setup test environment"
952                 "${GIT_TEST_INSTALLED:-$GIT_EXEC_PATH}/git$X" init \
953                         "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
954                 error "cannot run git init -- have you built things yet?"
955                 mv .git/hooks .git/hooks-disabled
956         ) || exit
957 }
958
959 # This function helps on symlink challenged file systems when it is not
960 # important that the file system entry is a symbolic link.
961 # Use test_ln_s_add instead of "ln -s x y && git add y" to add a
962 # symbolic link entry y to the index.
963
964 test_ln_s_add () {
965         if test_have_prereq SYMLINKS
966         then
967                 ln -s "$1" "$2" &&
968                 git update-index --add "$2"
969         else
970                 printf '%s' "$1" >"$2" &&
971                 ln_s_obj=$(git hash-object -w "$2") &&
972                 git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
973                 # pick up stat info from the file
974                 git update-index "$2"
975         fi
976 }
977
978 # This function writes out its parameters, one per line
979 test_write_lines () {
980         printf "%s\n" "$@"
981 }
982
983 perl () {
984         command "$PERL_PATH" "$@" 2>&7
985 } 7>&2 2>&4
986
987 # Is the value one of the various ways to spell a boolean true/false?
988 test_normalize_bool () {
989         git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
990 }
991
992 # Given a variable $1, normalize the value of it to one of "true",
993 # "false", or "auto" and store the result to it.
994 #
995 #     test_tristate GIT_TEST_HTTPD
996 #
997 # A variable set to an empty string is set to 'false'.
998 # A variable set to 'false' or 'auto' keeps its value.
999 # Anything else is set to 'true'.
1000 # An unset variable defaults to 'auto'.
1001 #
1002 # The last rule is to allow people to set the variable to an empty
1003 # string and export it to decline testing the particular feature
1004 # for versions both before and after this change.  We used to treat
1005 # both unset and empty variable as a signal for "do not test" and
1006 # took any non-empty string as "please test".
1007
1008 test_tristate () {
1009         if eval "test x\"\${$1+isset}\" = xisset"
1010         then
1011                 # explicitly set
1012                 eval "
1013                         case \"\$$1\" in
1014                         '')     $1=false ;;
1015                         auto)   ;;
1016                         *)      $1=\$(test_normalize_bool \$$1 || echo true) ;;
1017                         esac
1018                 "
1019         else
1020                 eval "$1=auto"
1021         fi
1022 }
1023
1024 # Exit the test suite, either by skipping all remaining tests or by
1025 # exiting with an error. If "$1" is "auto", we then we assume we were
1026 # opportunistically trying to set up some tests and we skip. If it is
1027 # "true", then we report a failure.
1028 #
1029 # The error/skip message should be given by $2.
1030 #
1031 test_skip_or_die () {
1032         case "$1" in
1033         auto)
1034                 skip_all=$2
1035                 test_done
1036                 ;;
1037         true)
1038                 error "$2"
1039                 ;;
1040         *)
1041                 error "BUG: test tristate is '$1' (real error: $2)"
1042         esac
1043 }
1044
1045 # The following mingw_* functions obey POSIX shell syntax, but are actually
1046 # bash scripts, and are meant to be used only with bash on Windows.
1047
1048 # A test_cmp function that treats LF and CRLF equal and avoids to fork
1049 # diff when possible.
1050 mingw_test_cmp () {
1051         # Read text into shell variables and compare them. If the results
1052         # are different, use regular diff to report the difference.
1053         local test_cmp_a= test_cmp_b=
1054
1055         # When text came from stdin (one argument is '-') we must feed it
1056         # to diff.
1057         local stdin_for_diff=
1058
1059         # Since it is difficult to detect the difference between an
1060         # empty input file and a failure to read the files, we go straight
1061         # to diff if one of the inputs is empty.
1062         if test -s "$1" && test -s "$2"
1063         then
1064                 # regular case: both files non-empty
1065                 mingw_read_file_strip_cr_ test_cmp_a <"$1"
1066                 mingw_read_file_strip_cr_ test_cmp_b <"$2"
1067         elif test -s "$1" && test "$2" = -
1068         then
1069                 # read 2nd file from stdin
1070                 mingw_read_file_strip_cr_ test_cmp_a <"$1"
1071                 mingw_read_file_strip_cr_ test_cmp_b
1072                 stdin_for_diff='<<<"$test_cmp_b"'
1073         elif test "$1" = - && test -s "$2"
1074         then
1075                 # read 1st file from stdin
1076                 mingw_read_file_strip_cr_ test_cmp_a
1077                 mingw_read_file_strip_cr_ test_cmp_b <"$2"
1078                 stdin_for_diff='<<<"$test_cmp_a"'
1079         fi
1080         test -n "$test_cmp_a" &&
1081         test -n "$test_cmp_b" &&
1082         test "$test_cmp_a" = "$test_cmp_b" ||
1083         eval "diff -u \"\$@\" $stdin_for_diff"
1084 }
1085
1086 # $1 is the name of the shell variable to fill in
1087 mingw_read_file_strip_cr_ () {
1088         # Read line-wise using LF as the line separator
1089         # and use IFS to strip CR.
1090         local line
1091         while :
1092         do
1093                 if IFS=$'\r' read -r -d $'\n' line
1094                 then
1095                         # good
1096                         line=$line$'\n'
1097                 else
1098                         # we get here at EOF, but also if the last line
1099                         # was not terminated by LF; in the latter case,
1100                         # some text was read
1101                         if test -z "$line"
1102                         then
1103                                 # EOF, really
1104                                 break
1105                         fi
1106                 fi
1107                 eval "$1=\$$1\$line"
1108         done
1109 }
1110
1111 # Like "env FOO=BAR some-program", but run inside a subshell, which means
1112 # it also works for shell functions (though those functions cannot impact
1113 # the environment outside of the test_env invocation).
1114 test_env () {
1115         (
1116                 while test $# -gt 0
1117                 do
1118                         case "$1" in
1119                         *=*)
1120                                 eval "${1%%=*}=\${1#*=}"
1121                                 eval "export ${1%%=*}"
1122                                 shift
1123                                 ;;
1124                         *)
1125                                 "$@" 2>&7
1126                                 exit
1127                                 ;;
1128                         esac
1129                 done
1130         )
1131 } 7>&2 2>&4
1132
1133 # Returns true if the numeric exit code in "$2" represents the expected signal
1134 # in "$1". Signals should be given numerically.
1135 test_match_signal () {
1136         if test "$2" = "$((128 + $1))"
1137         then
1138                 # POSIX
1139                 return 0
1140         elif test "$2" = "$((256 + $1))"
1141         then
1142                 # ksh
1143                 return 0
1144         fi
1145         return 1
1146 }
1147
1148 # Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
1149 test_copy_bytes () {
1150         perl -e '
1151                 my $len = $ARGV[1];
1152                 while ($len > 0) {
1153                         my $s;
1154                         my $nread = sysread(STDIN, $s, $len);
1155                         die "cannot read: $!" unless defined($nread);
1156                         last unless $nread;
1157                         print $s;
1158                         $len -= $nread;
1159                 }
1160         ' - "$1"
1161 }
1162
1163 # run "$@" inside a non-git directory
1164 nongit () {
1165         test -d non-repo ||
1166         mkdir non-repo ||
1167         return 1
1168
1169         (
1170                 GIT_CEILING_DIRECTORIES=$(pwd) &&
1171                 export GIT_CEILING_DIRECTORIES &&
1172                 cd non-repo &&
1173                 "$@" 2>&7
1174         )
1175 } 7>&2 2>&4
1176
1177 # convert stdin to pktline representation; note that empty input becomes an
1178 # empty packet, not a flush packet (for that you can just print 0000 yourself).
1179 packetize() {
1180         cat >packetize.tmp &&
1181         len=$(wc -c <packetize.tmp) &&
1182         printf '%04x%s' "$(($len + 4))" &&
1183         cat packetize.tmp &&
1184         rm -f packetize.tmp
1185 }
1186
1187 # Parse the input as a series of pktlines, writing the result to stdout.
1188 # Sideband markers are removed automatically, and the output is routed to
1189 # stderr if appropriate.
1190 #
1191 # NUL bytes are converted to "\\0" for ease of parsing with text tools.
1192 depacketize () {
1193         perl -e '
1194                 while (read(STDIN, $len, 4) == 4) {
1195                         if ($len eq "0000") {
1196                                 print "FLUSH\n";
1197                         } else {
1198                                 read(STDIN, $buf, hex($len) - 4);
1199                                 $buf =~ s/\0/\\0/g;
1200                                 if ($buf =~ s/^[\x2\x3]//) {
1201                                         print STDERR $buf;
1202                                 } else {
1203                                         $buf =~ s/^\x1//;
1204                                         print $buf;
1205                                 }
1206                         }
1207                 }
1208         '
1209 }
1210
1211 # Set the hash algorithm in use to $1.  Only useful when testing the testsuite.
1212 test_set_hash () {
1213         test_hash_algo="$1"
1214 }
1215
1216 # Detect the hash algorithm in use.
1217 test_detect_hash () {
1218         # Currently we only support SHA-1, but in the future this function will
1219         # actually detect the algorithm in use.
1220         test_hash_algo='sha1'
1221 }
1222
1223 # Load common hash metadata and common placeholder object IDs for use with
1224 # test_oid.
1225 test_oid_init () {
1226         test -n "$test_hash_algo" || test_detect_hash &&
1227         test_oid_cache <"$TEST_DIRECTORY/oid-info/hash-info" &&
1228         test_oid_cache <"$TEST_DIRECTORY/oid-info/oid"
1229 }
1230
1231 # Load key-value pairs from stdin suitable for use with test_oid.  Blank lines
1232 # and lines starting with "#" are ignored.  Keys must be shell identifier
1233 # characters.
1234 #
1235 # Examples:
1236 # rawsz sha1:20
1237 # rawsz sha256:32
1238 test_oid_cache () {
1239         local tag rest k v &&
1240
1241         { test -n "$test_hash_algo" || test_detect_hash; } &&
1242         while read tag rest
1243         do
1244                 case $tag in
1245                 \#*)
1246                         continue;;
1247                 ?*)
1248                         # non-empty
1249                         ;;
1250                 *)
1251                         # blank line
1252                         continue;;
1253                 esac &&
1254
1255                 k="${rest%:*}" &&
1256                 v="${rest#*:}" &&
1257
1258                 if ! expr "$k" : '[a-z0-9][a-z0-9]*$' >/dev/null
1259                 then
1260                         BUG 'bad hash algorithm'
1261                 fi &&
1262                 eval "test_oid_${k}_$tag=\"\$v\""
1263         done
1264 }
1265
1266 # Look up a per-hash value based on a key ($1).  The value must have been loaded
1267 # by test_oid_init or test_oid_cache.
1268 test_oid () {
1269         local var="test_oid_${test_hash_algo}_$1" &&
1270
1271         # If the variable is unset, we must be missing an entry for this
1272         # key-hash pair, so exit with an error.
1273         if eval "test -z \"\${$var+set}\""
1274         then
1275                 BUG "undefined key '$1'"
1276         fi &&
1277         eval "printf '%s' \"\${$var}\""
1278 }
1279
1280 # Choose a port number based on the test script's number and store it in
1281 # the given variable name, unless that variable already contains a number.
1282 test_set_port () {
1283         local var=$1 port
1284
1285         if test $# -ne 1 || test -z "$var"
1286         then
1287                 BUG "test_set_port requires a variable name"
1288         fi
1289
1290         eval port=\$$var
1291         case "$port" in
1292         "")
1293                 # No port is set in the given env var, use the test
1294                 # number as port number instead.
1295                 # Remove not only the leading 't', but all leading zeros
1296                 # as well, so the arithmetic below won't (mis)interpret
1297                 # a test number like '0123' as an octal value.
1298                 port=${this_test#${this_test%%[1-9]*}}
1299                 if test "${port:-0}" -lt 1024
1300                 then
1301                         # root-only port, use a larger one instead.
1302                         port=$(($port + 10000))
1303                 fi
1304                 ;;
1305         *[!0-9]*|0*)
1306                 error >&7 "invalid port number: $port"
1307                 ;;
1308         *)
1309                 # The user has specified the port.
1310                 ;;
1311         esac
1312
1313         # Make sure that parallel '--stress' test jobs get different
1314         # ports.
1315         port=$(($port + ${GIT_TEST_STRESS_JOB_NR:-0}))
1316         eval $var=$port
1317 }